/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.alibaba.excel.enums.CellDataTypeEnum
 *  com.alibaba.excel.metadata.Head
 *  com.alibaba.excel.metadata.data.CellData
 *  com.alibaba.excel.metadata.data.WriteCellData
 *  com.alibaba.excel.write.handler.CellWriteHandler
 *  com.alibaba.excel.write.handler.context.CellWriteHandlerContext
 *  com.alibaba.excel.write.metadata.holder.WriteSheetHolder
 *  com.alibaba.excel.write.metadata.holder.WriteTableHolder
 *  com.alibaba.excel.write.style.column.AbstractColumnWidthStyleStrategy
 *  org.apache.poi.ss.usermodel.Cell
 *  org.apache.poi.ss.usermodel.Sheet
 *  org.apache.poi.ss.util.CellRangeAddress
 */
package com.deepexi.scd.calculate.util;

import com.alibaba.excel.enums.CellDataTypeEnum;
import com.alibaba.excel.metadata.Head;
import com.alibaba.excel.metadata.data.CellData;
import com.alibaba.excel.metadata.data.WriteCellData;
import com.alibaba.excel.write.handler.CellWriteHandler;
import com.alibaba.excel.write.handler.context.CellWriteHandlerContext;
import com.alibaba.excel.write.metadata.holder.WriteSheetHolder;
import com.alibaba.excel.write.metadata.holder.WriteTableHolder;
import com.alibaba.excel.write.style.column.AbstractColumnWidthStyleStrategy;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.util.CellRangeAddress;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CustomLoopMergeStrategy
extends AbstractColumnWidthStyleStrategy
implements CellWriteHandler {
    private static final Logger log = LoggerFactory.getLogger(CustomLoopMergeStrategy.class);
    private int[] mergeColumnIndexes;
    List<Integer> segs;
    private int mergeRowIndex;
    private Map<Integer, Map<Integer, Integer>> CACHE = new HashMap<Integer, Map<Integer, Integer>>();

    public CustomLoopMergeStrategy(int mergeRowIndex, List<Integer> segs, int ... mergeColumnIndex) {
        this.mergeColumnIndexes = mergeColumnIndex;
        this.mergeRowIndex = mergeRowIndex;
        this.segs = segs;
    }

    public void afterCellDispose(CellWriteHandlerContext context) {
        super.afterCellDispose(context);
        this.afterCellDispose(context.getWriteSheetHolder(), context.getWriteTableHolder(), context.getCellDataList(), context.getCell(), context.getHeadData(), context.getRelativeRowIndex(), context.getHead());
    }

    public void afterCellDispose(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, List<WriteCellData<?>> cellDataList, Cell cell, Head head, Integer relativeRowIndex, Boolean isHead) {
        int curRowIndex = cell.getRowIndex();
        int curColIndex = cell.getColumnIndex();
        if (curRowIndex > this.mergeRowIndex) {
            for (int columnIndex : this.mergeColumnIndexes) {
                if (curColIndex != columnIndex) continue;
                this.mergeWithPrevRow(writeSheetHolder, cell, curRowIndex, curColIndex);
                break;
            }
        }
    }

    private void mergeWithPrevRow(WriteSheetHolder writeSheetHolder, Cell cell, int curRowIndex, int curColIndex) {
        Cell preCell = cell.getSheet().getRow(curRowIndex - 1).getCell(curColIndex);
        if (!this.segs.contains(curRowIndex - 1)) {
            Sheet sheet = writeSheetHolder.getSheet();
            List mergedRegions = sheet.getMergedRegions();
            boolean isMerged = false;
            for (int i = 0; i < mergedRegions.size() && !isMerged; ++i) {
                CellRangeAddress cellAddresses = (CellRangeAddress)mergedRegions.get(i);
                if (!cellAddresses.isInRange(curRowIndex - 1, curColIndex)) continue;
                sheet.removeMergedRegion(i);
                cellAddresses.setLastRow(curRowIndex);
                sheet.addMergedRegion(cellAddresses);
                isMerged = true;
            }
            if (!isMerged) {
                CellRangeAddress cellAddresses = new CellRangeAddress(curRowIndex - 1, curRowIndex, curColIndex, curColIndex);
                sheet.addMergedRegion(cellAddresses);
            }
        }
    }

    protected void setColumnWidth(WriteSheetHolder writeSheetHolder, List<WriteCellData<?>> cellDataList, Cell cell, Head head, Integer relativeRowIndex, Boolean isHead) {
        boolean needSetWidth = isHead;
        if (needSetWidth || Integer.valueOf(1).equals(relativeRowIndex)) {
            Integer columnWidth;
            Map<Integer, Integer> maxColumnWidthMap = this.CACHE.get(writeSheetHolder.getSheetNo());
            if (maxColumnWidthMap == null) {
                maxColumnWidthMap = new HashMap<Integer, Integer>();
                this.CACHE.put(writeSheetHolder.getSheetNo(), maxColumnWidthMap);
            }
            if ((columnWidth = this.dataLength(cellDataList, cell, isHead)) >= 0) {
                Integer maxColumnWidth;
                if (columnWidth > 255) {
                    columnWidth = 255;
                }
                if ((maxColumnWidth = maxColumnWidthMap.get(cell.getColumnIndex())) == null || columnWidth > maxColumnWidth) {
                    maxColumnWidthMap.put(cell.getColumnIndex(), columnWidth);
                    writeSheetHolder.getSheet().setColumnWidth(cell.getColumnIndex(), columnWidth * 256);
                }
            }
        }
    }

    public void afterCellCreate(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, Cell cell, Head head, Integer relativeRowIndex, Boolean isHead) {
        super.afterCellCreate(writeSheetHolder, writeTableHolder, cell, head, relativeRowIndex, isHead);
    }

    private Integer dataLength(List<WriteCellData<?>> cellDataList, Cell cell, Boolean isHead) {
        if (isHead.booleanValue()) {
            return Math.max(cell.getStringCellValue().getBytes().length + 4, 8);
        }
        CellData cellData = (CellData)cellDataList.get(0);
        CellDataTypeEnum type = cellData.getType();
        if (type == null) {
            return -1;
        }
        switch (type) {
            case STRING: {
                return cellData.getStringValue().getBytes().length;
            }
            case BOOLEAN: {
                return cellData.getBooleanValue().toString().getBytes().length;
            }
            case NUMBER: {
                return cellData.getNumberValue().toString().getBytes().length;
            }
            case DATE: {
                return 20;
            }
        }
        return -1;
    }
}

